/*----------------------------------------------------------------------*/
/* main()  Contains the outermost loop of the simulation.               */
/*----------------------------------------------------------------------*/
void usage ()
{
  printf("Usage: %s\n\n\tOptions:\n", "irsim");
  printf("\tD=<dimensions> (default=2)\n");
  printf("\tHALF=n  (0=full duplex, 1=half duplex, default=1) \n");
  printf("\tX=n (0=X-Windows off 1 = on, default=0)\n");
  printf("\tDEMAND=<demand> Indicates whether to use demand-driven\n");
  printf("\t                 or time-slice multiplexing.  (default=1)\n");
  printf("\tSIZE=c1c2...cn size of network in powers of 2. 33 gives\n");
  printf("\t                 an 8x8 network, default = 44. (NOTE: number\n");
  printf("\t                 of dimensions must be specified before this\n");
  printf("\t                 parameter if different than the default.)\n");
  printf("\tDEBUG=n set debug level (default=0)\n");
  printf("\tBUFFERS=n set buffer depth of each input virtual channel\n");
  printf("            (must be > 1, default=8)\n");
  printf("\tINJECT=n set inject rate per inject epoch (default=1)\n");
  printf("\tPER=n set inject epoch.  The simulation will inject on\n");
  printf("\t          average INJECT messages per node every PER\n");
  printf("\t          network cycles (default=1000)\n");
  printf("\tSECURITY_LEVELS=n set number of security level\n");
  printf("\tRDELAY= routing header intra-node delay in network\n");
  printf("\t           cycles (default=1)\n");
  printf("\tADELAY= acknowledgement flit intra-node delay in network\n");
  printf("\t           cycles (default=1)\n");
  printf("\tDDELAY= data flit intra-node delay in network\n");
  printf("\t           cycles (default=1)\n");
  printf("\tHSPOTS=n  set the number of network hot spots (default=0).\n");
  printf("\tHSPLACE=c1c2..cn  set the location of a hotspot.\n");
  printf("\t           A=10, Z=36, a=37, z=73\n");
  printf("\t           (may be used repeatedly.  Otherwise hot spots\n");
  printf("\t           are randomly placed.)\n");
  printf("\tM=n  set the number misroutes allowed by MB-m routing\n");
  printf("\t           protocol. (default=3)\n");
  printf("\tNO_CTS=n  0=CTS lookahead used, 1=CTS lookahead not used.\n");
  printf("\t           (default=0)\n");
  printf("\tMAP=n  0=No congestion map generated, 1=Generate congestion\n");
  printf("\t           map file. (default=0)\n");
  printf("\tSLOW=n  1=Place one second delays between flit movement stages\n");
  printf("\t           (Helps in debugging. default=0)\n");
  printf("\tFAULTS=n  Number of static virtual channel faults to place\n");
  printf("\t           randomly in the network (default=0)\n");
  printf("\tPFAULTS=n Number of static physical link faults to place\n");
  printf("\tTRANS=n   1=display transient statistics (default=1)\n");
  printf("\tCOMM=<communication mechanism>\n");
  printf("\t\tW = wormhole routing (WR)\n");
  printf("\t\tP = pipelined circuit-switching (PCS)\n");
  printf("\t\tAP = acknowledged PCS\n");
  printf("\t\tAx = acknowledged WR\n");
  printf("\t\tR = recon routing\n");
  printf("\t\tThis is set correctly by PROTO. WR is not compatible\n");
  printf("\t\twith some routing protocols.\n");
  printf("\tSCOUT=n  number of acks the routing header sends back to the\n");
  printf("\t\t dest before the data flits are sent.  Recon routing.\n");
  printf("\tSRCQ=n  number of injection queues (default=8)\n");
  printf("\tTRACE=trace_fn  Turns on trace driven simulation.  Specifies\n");
  printf("\t\t trace file.\n");
  printf("\tPROTO=<routing protocol>\n");
  printf("\t\tE = Ecube (defaults to WR communication mechanism)\n");
  printf("\t\tD = Duato (psuedo-min congestion selection function) (WR)\n");
  printf("\t\tM = Duato with m misroutes (AWR)\n");
  printf("\t\tO = Duato (Dimension Order selection function) (WR)\n");
  printf("\t\tC = Duato (Minimum congestion selection function) (WR)\n");
  printf("\t\tN = Negative First (WR)\n");
  printf("\t\tR = Dimension Reversal (WR)\n");
  printf("\t\tL = Misrouting Backtracking-m (PCS)\n");
  printf("\t\tP = MB-m + (PCS)\n");
  printf("\t\tA = A1 (PCS)\n");
  printf("\t\tT = Two-phase Backtracking (PCS)\n");
  printf("\t\tB = Exhaustive Profitable Backtracking (PCS)\n");
  printf("\t\tF = MB-m SW (PCS)\n");
  printf("\t\tI = Directional Ordered Routing (WR)\n");
  printf("\tSELECT=<selection function>\n");
  printf("\t\tN = Normal (psuedo-minimum congestion)\n");
  printf("\t\tM = Minimum congestion\n");
  printf("\t\tO = Dimension Order\n");
  printf("\tORDER=specify order of traversal for dor and mesh or toroid\n");
  printf("\t\t0 = DOR using y+x+y-x- (toroid)\n");
  printf("\t\t1 = DOR using y+x+x-y- (toroid)\n");
  printf("\t\t2 = DOR using y+x+y-x- (mesh)\n");
  printf("\t\t3 = DOR using y+x+x-y- (mesh)\n");
  printf("\t\t0 = Ecube (toroid)\n");
  printf("\t\t1 = Ecube (mesh)\n");
  printf("\tVARY=0/1 Turn off/on halving of virtual channels in different\n");
  printf("\t\t dimensions.  0 = off, 1 = on\n");
  printf("\tMSGL=<message length in flits>\n");
  printf("\tDUR=<duration of simulation in network clock cycles>\n");
  printf("\tVIRTS=<number of virtual channels per physical link direction>\n");
  printf("\tRADIUS=Size of exhaustive search radius for MB-m SW\n");
  printf("\tDIST=<distance/communication pattern>\n");
  printf("\t\tDIST=0 Random destinations selected from entire network\n");
  printf("\t\tDIST=-100 Bit reversal message pattern\n");
  printf("\t\tDIST=-900 Transpose message pattern\n");
  printf("\t\tDIST=-999 Perfect shuffle message pattern\n");
  printf("\t\tDIST=-1000 Flip bits message pattern\n");
  printf("\t\tDIST=-1001 Hot spot message pattern\n");
  printf("\t\tDIST>0 Random destinations selected from box DISTx...xDIST\n");
  printf("\t\t    centered on source node.\n");
  printf("\t\tDIST<0 Random destinations selected such that the distance\n");
  printf("\t\t    from source to destination is exactly |DIST|.\n");
  printf("\t\t(default = 4)\n");
  printf("\tDIST=<distance/communication pattern>\n");
  printf("\tDYN=n  Number of dynamic virtual channel faults\n");
  printf("\tPDYN=n Number of dynamic physical channel faults\n");
  exit(1);
}

void main() {
  usage();
}
